// This is code take from Zear's "Fountains of Paradise" map.
// I've made it a separate script so that the statis field
// can be use in different levels
//
// The "GravForceField" is based on stasis.
//
// |Legolas|

echo("------------- Running CustomForceFields.cs");

datablock ForceFieldBareData(electricForceFieldBare)
{
   fadeMS           = 1000;
   baseTranslucency = 0.9;
   powerOffTranslucency = 0.0;
   teamPermiable    = false;
   otherPermiable   = false;
   color            = "0.0 0.55 0.99";
   powerOffColor    = "0.0 0.0 0.0";
   targetTypeTag    = 'ForceField';

   texture[0] = "special/lightning1frame1";
   texture[1] = "special/lightning1frame2";
   texture[2] = "special/lightning1frame3";

   framesPerSec = 12;
   numFrames = 3;
   scrollSpeed = 12;
   umapping = 0.1;
   vmapping = 0.01;
};

datablock ForceFieldBareData(electricTeamFieldBare)
{
   fadeMS           = 1000;
   baseTranslucency = 0.9;
   powerOffTranslucency = 0.0;
   teamPermiable    = true;
   otherPermiable   = false;
   color            = "0.0 0.55 0.99";
   powerOffColor    = "0.0 0.0 0.0";
   targetTypeTag    = 'ForceField';

   texture[0] = "special/lightning1frame1";
   texture[1] = "special/lightning1frame2";
   texture[2] = "special/lightning1frame3";

   framesPerSec = 12;
   numFrames = 3;
   scrollSpeed = 12;
   umapping = 0.1;
   vmapping = 0.01;
};

datablock ForceFieldBareData(electricAllFieldBare)
{
   fadeMS           = 1000;
   baseTranslucency = 0.9;
   powerOffTranslucency = 0.0;
   teamPermiable    = true;
   otherPermiable   = true;
   color            = "0.0 0.55 0.99";
   powerOffColor    = "0.0 0.0 0.0";
   targetTypeTag    = 'ForceField';

   texture[0] = "special/lightning1frame1";
   texture[1] = "special/lightning1frame2";
   texture[2] = "special/lightning1frame3";

   framesPerSec = 12;
   numFrames = 3;
   scrollSpeed = 12;
   umapping = 0.1;
   vmapping = 0.01;
};

datablock ForceFieldBareData(electricNoTeamFieldBare)
{
   fadeMS           = 1000;
   baseTranslucency = 0.9;
   powerOffTranslucency = 0.0;
   teamPermiable    = false;
   otherPermiable   = true;
   color            = "0.0 0.55 0.99";
   powerOffColor    = "0.0 0.0 0.0";
   targetTypeTag    = 'ForceField';

   texture[0] = "special/lightning1frame1";
   texture[1] = "special/lightning1frame2";
   texture[2] = "special/lightning1frame3";

   framesPerSec = 12;
   numFrames = 3;
   scrollSpeed = 12;
   umapping = 0.1;
   vmapping = 0.01;
};

datablock ForceFieldBareData(stasisForceField)
{
   fadeMS           = 1000;
   baseTranslucency = 0.9;
   powerOffTranslucency = 0.0;
   teamPermiable    = false;
   otherPermiable   = false;
   color            = "1.0 1.0 1.0";
   powerOffColor    = "0.0 0.0 0.0";
   targetTypeTag    = 'ForceField'; 

   texture[0] = "skins/Enrgtubes0006.png";

   framesPerSec = 1;
   numFrames = 1;
   scrollSpeed = 0.5;
   umapping = 1.0;
   vmapping = 0.15;
};

datablock ForceFieldBareData(stasisTeamField)
{
   fadeMS           = 1000;
   baseTranslucency = 0.9;
   powerOffTranslucency = 0.0;
   teamPermiable    = true;
   otherPermiable   = false;
   color            = "1.0 1.0 1.0";
   powerOffColor    = "0.0 0.0 0.0";
   targetTypeTag    = 'ForceField';

   texture[0] = "skins/Enrgtubes0006.png";

   framesPerSec = 1;
   numFrames = 1;
   scrollSpeed = 0.5;
   umapping = 1.0;
   vmapping = 0.15;
};

datablock ForceFieldBareData(stasisAllField)
{
   fadeMS           = 1000;
   baseTranslucency = 0.9;
   powerOffTranslucency = 0.0;
   teamPermiable    = true;
   otherPermiable   = true;
   color            = "1.0 1.0 1.0";
   powerOffColor    = "0.0 0.0 0.0";
   targetTypeTag    = 'ForceField';

   texture[0] = "skins/Enrgtubes0006.png";

   framesPerSec = 1;
   numFrames = 1;
   scrollSpeed = 0.5;
   umapping = 1.0;
   vmapping = 0.15;
};

datablock ForceFieldBareData(stasisNoTeamField)
{
   fadeMS           = 1000;
   baseTranslucency = 0.9;
   powerOffTranslucency = 0.0;
   teamPermiable    = false;
   otherPermiable   = true;
   color            = "1.0 1.0 1.0";
   powerOffColor    = "0.0 0.0 0.0";
   targetTypeTag    = 'ForceField';

   texture[0] = "skins/Enrgtubes0006.png";

   framesPerSec = 1;
   numFrames = 1;
   scrollSpeed = 0.5;
   umapping = 1.0;
   vmapping = 0.15;
};

datablock ForceFieldBareData(TransferFieldForceField)
{
   fadeMS           = 1000;
   baseTranslucency = 0.9;
   powerOffTranslucency = 0.0;
   teamPermiable    = true;
   otherPermiable   = true;
   color            = "0.73 0.09 1.0";
   powerOffColor    = "0.0 0.0 0.0";
   targetTypeTag    = 'ForceField'; 

   texture[0] = "skins/nexred15.png";

   framesPerSec = 1;
   numFrames = 1;
   scrollSpeed = -1;
   umapping = 1.0;
   vmapping = 0.15;
};

function ForceFieldBareData::onAdd(%data, %obj)
{
   Parent::onAdd(%data, %obj);

   %velo = 1;
   %grav = 0.1;
   %appl = "0 0 0";

   if(%obj.custom $= "1")
   {
      %velo = %obj.velocityMod;
      %grav = %obj.gravityMod;
      %appl = %obj.appliedForce;
   }

   %pz = new PhysicalZone() {
      position = %obj.position;
      rotation = %obj.rotation;
      scale    = %obj.scale;
      polyhedron = "0.000000 1.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
      velocityMod  = %velo;
      gravityMod   = %grav;
      appliedForce = %appl;
		ffield = %obj;
   };

   %pzGroup = nameToID("MissionCleanup/PZones");
   if(%pzGroup <= 0)
   {
      %pzGroup = new SimGroup("PZones");
      MissionCleanup.add(%pzGroup);
   }
   %pzGroup.add(%pz);
}

