// don't want this executing when building graphs
if($OFFLINE_NAV_BUILD)
   return;

datablock AudioDescription(FnIaudio)
{
   volume   = 1.0;
   isLooping= false;
   is3D     = false;
   type     = $EffectAudioType;
};

datablock AudioProfile(FnIzap)
{
   filename    = "fx/misc/lightning_impact.wav";
   description = "FnIaudio";
	  preload = true;
};

activatePackage(FireAndIce);
   
package FireAndIce {
// Start of function definitions ===============================================

function GameConnection::startMission(%this)
{
    echo("----- Entering startMission");
    MissionGroup.musicTrack = getRandomTrack();
    echo("musicTrack is " @ MissionGroup.musicTrack);
    parent::startMission(%this);
}

function getRandomTrack()
{
   %val = mFloor(getRandom(0, 4));
   switch(%val)
   {
      case 0:
         return "lush";
      case 1:
         return "volcanic";
      case 2:
         return "badlands";
      case 3:
         return "ice";
      case 4:
         return "desert";
   }
}

function VehicleData::onImpact(%data, %vehicleObject, %collidedObject, %vec, %vecLen)
{
    //echo("-------- Entering onImpact");
    parent::onImpact(%data, %vehicleObject, %collidedObject, %vec, %vecLen);
    //echo("TowerSupportFF1 ID = " @ game.TowerSuppFF1 @ ", Position = " @ game.TowerSuppFF1.getPosition());
    //echo("data=" @ %data @ ", vehicleObject=" @ %vehicleObject @ ",collidedObject=" @ %collidedObject);
    for(%i = 0;  %i < game.TowerSuppNo;  %i++) {
        if(%inArea = nearSupport(game.TowerSuppFF[%i], %vehicleObject))
            break;
    }
    //echo("inArea is " @ %inArea);
    if(%inArea) {
        if(%vehicleObject.respawnTime !$= "")
            %vehicleObject.marker.schedule = %vehicleObject.marker.data.schedule(%vehicleObject.respawnTime, "respawn", %vehicleObject.marker);
        %vehicleObject.setDamageState(Destroyed);
    }
}

function nearSupport(%supp, %obj)
{
    %suppPos = %supp.getPosition();
    %objPos = %obj.getPosition();
    %suppX = getWord(%suppPos,0);
    %suppY = getWord(%suppPos,1);
    %objX = getWord(%objPos,0);
    %objY = getWord(%objPos,1);
    
    //echo("suppPos=" @ %suppPos @ ", suppX=" @ %suppX @ ", suppY=" @ %suppY);
    //echo("objPos=" @ %objPos @ ", objX=" @ %objX @ ", objY=" @ %objY);
    
    //use 10 for havoc & tank, 20 for bomber, 25 for transport (don't know MPB)
    //go with 25 for now and see how it plays
    %targetRad = 25;
    %dX = %suppX - %objX;
    %dY = %suppY - %objY;
    %dist = mSqrt((%dX * %dX) + (%dY * %dY));
    //echo("dist is " @ %dist @ ", dX=" @ %dX @ ", dY=" @ %dY);
    return (%dist <= %targetRad);
}

function defaultTrigger::onEnterTrigger(%data, %obj, %colObj)
{
    //echo("-------- Entering trigger");
    %dataBlock = %colObj.getDataBlock();
    %className = %dataBlock.className;
    %client = %colObj.client;
    %player = %client.player;
    //echo("%className is " @ %className @ ", %client is " @ %client @ ", %player is " @ %player);
    if(%player) {
        //alxPlay(FnIzap, 0, 0, 0);
        %player.playAudio($PlaySound, FnIzap);
        %player.blowup(); // chunkOrama!
        %player.scriptkill($DamageType::ForceFieldPowerup);
    }
}

function defaultTrigger::onLeaveTrigger(%data, %obj, %colObj)
{
    //echo("-------- Leaving trigger");
    return;
}

function defaultTrigger::onTickTrigger(%data, %obj)
{
    //echo("-------- Trigger Tick");
    return;
}

function rotateTeamFFs(%time)
{
	//echo("-------------Entering rotateTeamFFs");
    if(!$MatchStarted) {
    	echo("------------- rotateTeamsFFs: Waiting on match to start...");
        game.FFRotate = schedule(%time, game, rotateTeamFFs, %time);
        return;
    }

	if(%time == 0)
	{
		// stop rotation
		cancel(game.FFRotate);
		// set Disable FF's
		game.Team1FFGen.setDamageState(Disabled);	
	}
	else
	{
		// start these bad boys rotating while tower gens are up
		game.FFGenCtl = !game.FFGenCtl;
		if(game.FFGenCtl) { %time = game.FnIenableTime; }
        else { %time = game.FnIdisableTime; }
        // Team 1 FFs
		if(game.Team1Gen1.isDisabled() && game.Team1Gen2.isDisabled()) {
			//echo("------------- Team 1 target Gens destroyed");
            if(!game.Team1FFGen.isDisabled) {
                game.Team1FFGen.setDamageState(Disabled);
            }
		}
		else {
			if(game.FFGenCtl) {
				//echo("-------------Enable Team 1 Generator");
				game.Team1FFGen.setDamageState(Enabled);
			}
			else {
				//echo("-------------Disable Team 1 Generator");
				game.Team1FFGen.setDamageState(Disabled);
			}
		}
        // Team 2 FFs
		if(game.Team2Gen1.isDisabled() && game.Team2Gen2.isDisabled()) {
			//echo("------------- Team 2 target Gens destroyed");
            if(!game.Team2FFGen.isDisabled) {
                game.Team2FFGen.setDamageState(Disabled);
            }
		}
		else {
			if(game.FFGenCtl) {
				//echo("-------------Team 2 Enable Generator");
				game.Team2FFGen.setDamageState(Enabled);
			}
			else {
				//echo("-------------Team 2 Disable Generator");
				game.Team2FFGen.setDamageState(Disabled);
			}
		}

		game.FFRotate = schedule(%time, game, rotateTeamFFs, %time);
	}
}

function randomFnI()
{
    if($FnIobjects $= "")
        %numObj = 150;
    else
        %numObj = $FnIobjects;
    if(%numObj <= 0)
        return;
    if(%numObj > 400)  // Lets not get to carried away!
        %numObj = 150;

    addRndObj("c FnIR6 nul 75 0 1 0.8 2 1 0 srock6.dif 0 0 0 R R R 1.3 1.3 1.3"); // rock
    addRndObj("c FnIR8 nul 75 0 1 0.8 1.4 1 0 srock8.dif 0 0 0 R R R 1 1 1"); // rock
    addRndObj("v FnIrocks 2 FnIR6 3 FnIR8 7");

    addRndObj("s FnISP1 sspir1.dif 10 -3.0 R 0.5 1.5");
    addRndObj("s FnISP2 sspir2.dif 10 -3.0 R 0.5 1.5");
    addRndObj("s FnISP3 sspir3.dif 10 -3.0 R 0.5 1.5");
    addRndObj("s FnISP4 sspir4.dif 10 -3.0 R 0.5 1.5");
    addRndObj("v FnIspears 4 FnISP1 3 FnISP2 3 FnISP3 3 FnISP4 1");

    addRndObj("v FnI 2 FnIrocks 4 FnIspears 1");

    //echo("numObj = " @ %numObj);
    rndObjMission(FnI, %numObj);
}

// End of function definitions =================================================
};

echo("---------------- Running FireAndIce.cs");

game.Team1Gen1 = nameToId("Team1BunkerGen1");
game.Team1Gen2 = nameToId("Team1BunkerGen2");
game.Team1FFGen = nameToId("Team1FlagFF1Gen");
game.Team2Gen1 = nameToId("Team2BunkerGen1");
game.Team2Gen2 = nameToId("Team2BunkerGen2");
game.Team2FFGen = nameToId("Team2FlagFF1Gen");
game.TowerSuppNo = 6;
game.TowerSuppFF[0] = nameToId("TowerSupportFF1");
game.TowerSuppFF[1] = nameToId("TowerSupportFF2");
game.TowerSuppFF[2] = nameToId("TowerSupportFF3");
game.TowerSuppFF[3] = nameToId("TowerSupportFF4");
game.TowerSuppFF[4] = nameToId("TowerSupportFF5");
game.TowerSuppFF[5] = nameToId("TowerSupportFF6");
game.FFGenCtl = false;

// Add Random stuff
randomFnI();
// Start the rotation
game.FnIenableTime = $FnIenableTime $= "" ? 9000 : $FnIenableTime * 1000;
if(game.FnIenableTime < 2000)  // allow enough time for the FF to fade in/out
    game.FnIenableTime = 2000;
game.FnIdisableTime = $FnIdisableTime $= "" ? 6000 : $FnIdisableTime * 1000;
if(game.FnIdisableTime < 2000) // allow enough time for the FF to fade in/out
    game.FnIdisableTime = 2000;
//echo("Enable = " @ game.FnIenableTime @ ", Disable = " @ game.FnIdisableTime);
%time = 4000;
game.FFRotate = schedule(%time, game, rotateTeamFFs, %time);

